From: "Angus Ainslie (Purism)" <angus@akkea.ca>
Date: Wed, 25 Sep 2019 07:22:13 -0700
Subject: net: wireless: redpine: get version mumber from flash

Read the version number from the flash module

Signed-off-by: Angus Ainslie (Purism) <angus@akkea.ca>
---
 drivers/net/wireless/redpine/rsi_91x_hal.c  | 22 ++++++++++++++++++++++
 drivers/net/wireless/redpine/rsi_91x_main.c |  6 ++++--
 drivers/net/wireless/redpine/rsi_hal.h      |  3 +++
 3 files changed, 29 insertions(+), 2 deletions(-)

diff --git a/drivers/net/wireless/redpine/rsi_91x_hal.c b/drivers/net/wireless/redpine/rsi_91x_hal.c
index 7df427f..f3e8cbc 100644
--- a/drivers/net/wireless/redpine/rsi_91x_hal.c
+++ b/drivers/net/wireless/redpine/rsi_91x_hal.c
@@ -1279,6 +1279,7 @@ static int rsi_load_firmware(struct rsi_hw *adapter)
 
 #ifdef CONFIG_REDPINE_PURISM
 	u32 flash_data_start = 0;
+	u8 flash_read[RSI_MAX_FLASH_OFFSET_SIZE];
 #endif
 	struct ta_metadata *metadata_p;
 	int status;
@@ -1350,6 +1351,27 @@ static int rsi_load_firmware(struct rsi_hw *adapter)
 		if (flash_data_start == 0x5aa5) {
 			status = rsi_load_9116_flash_fw(adapter);
 			mdelay(3000);
+			if ((hif_ops->master_reg_read(adapter,
+					RSI_FLASH_READ_FW_VER,					
+					(int *)flash_read,
+					4)) < 0) {
+			redpine_dbg(ERR_ZONE,
+				"%s: RSI_FLASH_READ_FW_VER failed\n", __func__);
+				goto bl_cmd_fail;
+			}
+			common->lmac_ver.major = flash_read[2];
+			common->lmac_ver.minor = flash_read[3];
+			if ((hif_ops->master_reg_read(adapter,
+					RSI_FLASH_READ_FW_VER1,
+					(int *)flash_read,
+					4)) < 0) {
+			redpine_dbg(ERR_ZONE,
+				"%s: RSI_FLASH_READ_FW_VER failed\n", __func__);
+				goto bl_cmd_fail;
+			}
+			common->lmac_ver.release_num = flash_read[0];
+			common->lmac_ver.patch_num = flash_read[2];
+			rsi_print_version(common);
 			if (adapter->rsi_host_intf == RSI_HOST_INTF_USB) {
 				if (bl_cmd(adapter, POLLING_MODE,
 					   CMD_PASS, "POLLING_MODE") < 0) {
diff --git a/drivers/net/wireless/redpine/rsi_91x_main.c b/drivers/net/wireless/redpine/rsi_91x_main.c
index c6c35a3..5700385 100644
--- a/drivers/net/wireless/redpine/rsi_91x_main.c
+++ b/drivers/net/wireless/redpine/rsi_91x_main.c
@@ -283,13 +283,15 @@ void rsi_print_version(struct rsi_common *common)
 	redpine_dbg(ERR_ZONE, "================================================\n");
 	redpine_dbg(ERR_ZONE, "================ RSI Version Info ==============\n");
 	redpine_dbg(ERR_ZONE, "================================================\n");
-	redpine_dbg(ERR_ZONE, "FW Version\t: %d.%d.%d\n",
+	redpine_dbg(ERR_ZONE, "FW Version\t: %d.%d.%d.%d\n",
 		common->lmac_ver.major, common->lmac_ver.minor,
-		common->lmac_ver.release_num);
+		common->lmac_ver.release_num,common->lmac_ver.patch_num);
 	redpine_dbg(ERR_ZONE, "Driver Version\t: %s", common->driver_ver);
 	redpine_dbg(ERR_ZONE, "Operating mode\t: %d [%s]",
 		common->oper_mode, opmode_str(common->oper_mode));
+#ifndef CONFIG_REDPINE_PURISM
 	redpine_dbg(ERR_ZONE, "Firmware file\t: %s", common->priv->fw_file_name);
+#endif
 	redpine_dbg(ERR_ZONE, "================================================\n");
 }
 
diff --git a/drivers/net/wireless/redpine/rsi_hal.h b/drivers/net/wireless/redpine/rsi_hal.h
index f087f6b..0a8bfbf 100644
--- a/drivers/net/wireless/redpine/rsi_hal.h
+++ b/drivers/net/wireless/redpine/rsi_hal.h
@@ -72,7 +72,10 @@
 
 #ifdef CONFIG_REDPINE_PURISM
 #define RSI_FLASH_READ_COEX_IMAGE       (0x04000000 + 0x80000 + 0x40)
+#define RSI_FLASH_READ_FW_VER		0x00002c04
+#define RSI_FLASH_READ_FW_VER1		0x00002c08
 #define RSI_FLASH_READ_WLAN_IMAGE       (0x04000000 + 0x20000 + 0x40)
+#define RSI_MAX_FLASH_OFFSET_SIZE	0x4
 #endif
 
 #define SWBL_REGIN			0x41050034
